image: docker:stable-git

stages:
  - docker
  - build

services:
  - docker:dind

variables:
  DOCKER_DRIVER: overlay2

# Build and archive image
build docker:
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" "$CI_REGISTRY"
  stage: docker
  # Only build for commits tagget with 'dockergit remote add origin'
  only:
    - /^docker$/
  tags:
    - docker
  script:
    - docker build --cache-from $CI_REGISTRY_IMAGE:latest --tag $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA --tag $CI_REGISTRY_IMAGE:latest .
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
    - docker push $CI_REGISTRY_IMAGE:latest

build code:
  image: $CI_REGISTRY_IMAGE:latest
  stage: build
  tags: 
    - docker
  script:
    - platformio run
    # Fix paths for artifact view
    - cp .pio/build/teensy40/*.hex ./
    - cp .pio/build/teensy40/*.elf ./
  artifacts:
    paths:
      - "./*.hex"
      - "./*.elf"

